// components/orderItem/orderItem.js
Component({

  /**
   * 组件的属性列表
   */
  properties: {
    order:{
      type:Object,
      // value:{
      //   oilName:'92号汽油',
      //   nozzleNum:'5',
      //   volume:'19.9',
      //   amount:'46.8',
      //   date:'2024-11-24',
      //   time:'09:28',
      //   status:'已授权'
      // }
    },
    statusColor:{
      type:String,
      // value:"#88b743"
    },
    countdown:{
      type:String,
      // value:""
    },
    buttonMessage1:{
      type:String,
      // value:"按钮一"
    },
    buttonMessage2:{
      type:String,
      // value:"按钮二"
    },
    buttonColor1:{
      type:String,
      // value:"#ee333a"
    },
    buttonColor2:{
      type:String,
      // value:"#97c276"
    }
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    //第一个按钮的点击事件
    buttonClick1(){
      this.triggerEvent('bottonEvent1',{
        order:this.properties.order,
        event:3 //第一个按钮只会传递取消订单
      })
    },
    //第二个按钮的点击事件
    buttonClick2(){
      /**第二个按钮会是去支付：1和去授权：2两种
       * 当当前订单状态为未支付或者支付失败时，第二个按钮点击就是去支付，event 传递1
       * 当当前订单状态为已失效时，第二个按钮点击就是去重新授权，event 传递2
       */
      var sendEvent = 1;
      if(this.properties.order.status == "已失效") sendEvent = 2
      this.triggerEvent('bottonEvent2',{
        order:this.properties.order,
        event:sendEvent
      })
    },
  }
})